

#include <string.h>
#include <stdio.h>
#include <process.h>

class Collection
{
	long	*dataPtr;
	int		dataSize;
	int		maxDataSize;
	int		delta;

  public:
	Collection( int size = 5, int delta = 5 );
	~Collection(){RemoveAll();};

	int		GetSize(){ return dataSize; };
	void	SetDelta( int dlt = 5 ){ delta = dlt; };

	int		Add( void* );
	int		Insert( int ,void* );
	int		Remove( void* );
	int		Remove( int );
	int		RemoveAll();
	int		Delete( void* );
	int		Delete( int );
	int		DeleteAll();
	void	*operator[]( int );
	void	operator +=( void* );
	void	ChangePlace( int , int );

//	virtual int operator==(void *, void *);

  protected:
	int		ReAllocateData( int );
	int		AddMemory();
	void	CheckBound( int i )
		{ 
			if( i > dataSize || i < 0 )
			{
				fprintf( stderr, " current array index is %d/%d/%d \n", 
						i, dataSize, maxDataSize );
				exit( -1 );
			}
		};
};

