#include <stdlib.h>
#include <string.h>

#include "sortdiffcoll.h"


int SortedDiffCollection::Add( char *s )
{
	char *ptr = strrchr( s, '.' );
	int res = -1;
	
	if( ptr && atoi( ++ptr ))
	{
		res = DiffCollection::Add( s );
		Sort();
	} else
		delete s;
		
	return res;	
}

void SortedDiffCollection::Sort()
{

	char *ptr1, *ptr2;
	for( int i=0; i<GetSize(); i++ )
	{
		ptr1 = strrchr( operator[]( i ), '.' );
		for( int j=i+1; j<GetSize(); j++ )
		{
			ptr2 = strrchr( operator[]( j ), '.' );
			if( atoi( ++ptr1 ) > atoi( ++ptr2 ))
			{
				ChangePlace( i, j );
/*				char *s1 = operator[]( i ),
					 *s2 = operator[]( j ),
					 *s3 = s1;
					 
					 s1 = s2;
					 s2 = s3;
*/
			}
		}
	}
}